-- 默认变量
BieChuDB = BieChuDB or {
	default = {
		font = {
			name = STANDARD_TEXT_FONT,
			size = 13,
			flags = 'OUTLINE',
		},
		value = {
			anchor = 'RIGHT',
			offsetX = -4,
			offsetY = -1,
		},
		percent = {
			anchor = 'LEFT',
			offsetY = -1,
		},
		healthColor = 1, -- 体力条颜色 1.如果是玩家按职业颜色 非玩家根据危险高从红黄绿变化, 2.所有根据危险高从红黄绿变化 3.如果是玩家按职业颜色 非玩家不改, 4.如果是玩家按危险高从红黄绿变化 非玩家不变, nil 所有默认不改
		-- classPortrait = false, -- 如果是玩家显示职业图标
		-- point = nil, -- 定位 {anchor, parent, offsetX, offsetY}
	},
	player = {
		value = {
			anchor = 'LEFT',
			offsetX = 4,
			offsetY = -1
		},
		percent = {
			anchor = 'RIGHT',
			offsetY = -1,
		},
		healthColor = 2,
		-- point = {
		-- 	anchor = 'CENTER',
		-- 	offsetX = -317,
		-- 	offsetY = -104,
		-- },
	},
	target = {
		-- point = {
		-- 	anchor = 'TOPLEFT',
		-- 	parent = 'PlayerFrame',
		-- 	offsetX = 600,
		-- 	offsetY = 0,
		-- },
	},
	focus = {
		-- point = {
		-- 	anchor = 'TOPLEFT',
		-- 	parent = 'PlayerFrame',
		-- 	offsetX = 336,
		-- 	offsetY = -60,
		-- }
	},
	targettarget = {
		font = {
			name = STANDARD_TEXT_FONT,
			size = 10,
			flags = 'OUTLINE'
		},
		value = {
			anchor = 'CENTER',
		},
		percent = false, -- 不显示百分比
		classPortrait = true,
	},
	focustarget = {
		font = {
			name = STANDARD_TEXT_FONT,
			size = 10,
			flags = 'OUTLINE',
		},
		value = {
			anchor = 'CENTER',
		},
		percent = false,
		classPortrait = true,
	},
	pet = {
		font = {
			name = STANDARD_TEXT_FONT,
			size = 10,
			flags = 'OUTLINE',
		},
		percent = {
			anchor = 'RIGHT',
			offsetX = -1,
			offsetY = -2
		},
		value = {
			anchor = 'LEFT',
			offsetX = 1,
			offsetY = -2
		},
	},
	party = {
		font = {
			name = STANDARD_TEXT_FONT,
			size = 10,
			flags = 'OUTLINE',
		},
		value = {
			anchor = 'LEFT',
			offsetX = 1,
			offsetY = -1,
		},
		percent = {
			anchor = 'RIGHT',
			offsetX = -1,
			offsetY = -1,
		},
		classPortrait = true,
	},
	party1 = {
		point = {
			anchor = 'TOPLEFT',
			parent = 'UIParent',
			offsetX = 160,
			offsetY = -350,
		}
	},
	party2 = {
		point = {
			anchor = 'TOPLEFT',
			parent = 'PartyMemberFrame1',
			offsetX = 0,
			offsetY = -100,
		}
	},
	party3 = {
		point = {
			anchor = 'TOPLEFT',
			parent = 'PartyMemberFrame2',
			offsetX = 0,
			offsetY = -100,
		}
	},
	party4 = {
		point = {
			anchor = 'TOPLEFT',
			parent = 'PartyMemberFrame3',
			offsetX = 0,
			offsetY = -100,
		}
	},
}
BieChuFrame = BieChuFrame or CreateFrame('Frame')
BieChuFrame.frameList = {
	player = {
		frame = PlayerFrame,
		health = PlayerFrameHealthBar,
		mana = PlayerFrameManaBar,
		hide = {
			PlayerFrameHealthBarText,
			PlayerFrameHealthBarTextLeft,
			PlayerFrameHealthBarTextRight,
			PlayerFrameManaBarText,
			PlayerFrameManaBarTextLeft,
			PlayerFrameManaBarTextRight,
		},
	},
	target = {
		frame = TargetFrame,
		health = TargetFrameHealthBar,
		mana = TargetFrameManaBar,
		hide = {
			TargetFrame.textureFrame.HealthBarText,
			TargetFrame.textureFrame.HealthBarTextLeft,
			TargetFrame.textureFrame.HealthBarTextRight,
			TargetFrame.textureFrame.ManaBarText,
			TargetFrame.textureFrame.ManaBarTextLeft,
			TargetFrame.textureFrame.ManaBarTextRight,
			TargetFrame.deadText, -- 隐藏默认死亡文字
		},
	},
	focus = {
		frame = FocusFrame,
		health = FocusFrameHealthBar,
		mana = FocusFrameManaBar,
		hide = {
			FocusFrame.textureFrame.HealthBarText,
			FocusFrame.textureFrame.HealthBarTextLeft,
			FocusFrame.textureFrame.HealthBarTextRight,
			FocusFrame.textureFrame.ManaBarText,
			FocusFrame.textureFrame.ManaBarTextLeft,
			FocusFrame.textureFrame.ManaBarTextRight,
			FocusFrame.deadText, -- 隐藏默认死亡文字
		},
	},
	targettarget = {
		frame = TargetFrame.totFrame,
		health = TargetFrame.totFrame.healthbar,
		mana = TargetFrame.totFrame.manabar,
		hide = {
			TargetFrame.totFrame.name, --隐藏目标的目标名字
		}
	},
	focustarget = {
		frame = FocusFrame.totFrame,
		health = FocusFrame.totFrame.healthbar,
		mana = FocusFrame.totFrame.manabar,
		hide = {
			FocusFrame.totFrame.name, --隐藏焦点的目标名字
		}
	},
	pet = {
		frame = PetFrame,
		health = PetFrameHealthBar,
		mana = PetFrameManaBar,
		hide = {
			PetName,
			PetFrameHealthBarText,
			PetFrameHealthBarTextLeft,
			PetFrameHealthBarTextRight,
			PetFrameManaBarText,
			PetFrameManaBarTextLeft,
			PetFrameManaBarTextRight,
		},
	},
}
for id = 1, MAX_PARTY_MEMBERS do
	-- 队友
	local party = 'party'.. id
	BieChuFrame.frameList[party] = {
		frame = getglobal('PartyMemberFrame'.. id),
		health = getglobal('PartyMemberFrame'.. id .. 'HealthBar'),
		mana = getglobal('PartyMemberFrame'.. id .. 'ManaBar'),
		hide = {
			getglobal('PartyMemberFrame'.. id ..'Name'), -- 队友名字
		},
	}
end

-- 自动读取默认变量
function BieChuFrame:GetFrameDB(unit, name)
	if not unit then return end
	local key = string.gsub(unit, '%d', '')
	if BieChuDB[unit] and BieChuDB[unit][name] ~= nil then
		return BieChuDB[unit][name]
	elseif BieChuDB[key] and BieChuDB[key][name] ~= nil then
		return BieChuDB[key][name]
	elseif BieChuDB.default then
		return BieChuDB.default[name]
	else
		return nil
	end
end

-- 非战斗中按住Shift + Alt拖动
function BieChuFrame:DragFarmes(frame, shift, alt)
	frame:EnableMouse(true)
	frame:SetMovable(true)
	frame:SetUserPlaced(true)
	frame:SetScript('OnMouseDown', function(self, button, ...)
		if button == 'LeftButton' and not InCombatLockdown() and (shift or IsShiftKeyDown()) and (alt or IsAltKeyDown()) then
			self:StartMoving()
		end
	end)
	frame:SetScript('OnMouseUp', frame.StopMovingOrSizing)
end

-- 体力条颜色
function BieChuFrame:HealthColor(unit, style)
	local r, g, b, a = UnitSelectionColor(unit)
	--1.如果是玩家按职业颜色 非玩家根据危险高从红黄绿变化, 2.所有根据危险高从红黄绿变化 3.如果是玩家按职业颜色 非玩家不改, 4.如果是玩家按危险高从红黄绿变化 非玩家不变, nil 所有默认不改
	if UnitIsPlayer(unit) and (style == 1 or style == 3) then -- 职业颜色
		local color = RAID_CLASS_COLORS[select(2, UnitClass(unit))]
		if color then
			r, g, b = color.r, color.g, color.b
			if UnitIsConnected(unit) then
				a = 1
			else  --离线 透明度
				a = 0.75
			end
		end
	elseif style == 1 or style == 2 or sytle == 4 and UnitIsPlayer(unit) then -- 职业颜色
		local percent =  UnitHealth(unit) / UnitHealthMax(unit)
		r, g, b, a = 0, 1, 0, 1, 1
		if percent > 0.5 then
			r = (1 - percent) * 2
		else
			r = 1
			g = percent * 2
		end
	end
	return r, g, b, a
end

-- 格式化数值
function BieChuFrame:formatValue(value)
	if type(value) == 'number' then
		if value >= 1e6 then
			return ('%.1fM'):format(value/1e6):gsub('%.?0+([km])$','%1')
		elseif value >= 1e4 then
			return ('%.1fK'):format(value/1e3):gsub('%.?0+([km])$','%1')
		else
			return value
		end
	else
		return 0
	end
end

-- 获取小队id
function BieChuFrame:PartyGID(unit)
	if UnitExists(unit) and UnitInParty(unit) and not UnitIsUnit('player', unit) then
		for i = 1, MAX_PARTY_MEMBERS do
			if UnitIsUnit(unit, 'party' .. i) then
				return i
			end
		end
	end
	return nil
end

-- 自动隐藏团队框架
function BieChuFrame:AutoHideRaidContainer()
	for i = 1, 8 do
		if getglobal('RaidPullout'.. i) then
			getglobal('RaidPullout'.. i):Hide()
			getglobal('RaidPullout'.. i):SetAlpha(0)
			getglobal('RaidPullout'.. i):SetScript('OnShow', function(self)
				self:Hide()
				self:SetAlpha(0)
			end)
		end
	end
	local partyNum = 1
	local raidNum = 0
	for i = 1, MAX_PARTY_MEMBERS do
		if UnitExists('party' .. i) and UnitIsConnected('party' .. i) then partyNum = partyNum + 1 end
	end
	for i = 1, MAX_RAID_MEMBERS do
		if UnitExists('raid' .. i) and UnitIsConnected('raid' .. i) then raidNum = raidNum + 1 end
	end
	if partyNum == raidNum then
		if CompactRaidFrameContainer then CompactRaidFrameContainer:Hide() end
		if CompactRaidFrameManager then CompactRaidFrameManager:Hide() end
	end
end

-- 创建
function BieChuFrame:frameCreate(frame)
	local list
	if frame and type(frame) == 'table' and frame.unit then
		list = {[frame.unit] = frame}
	else
		list = BieChuFrame.frameList
	end

	for unit, item in pairs(list) do
		if item.frame then
			local _

			local point = BieChuFrame:GetFrameDB(unit, 'point')
			local font = BieChuFrame:GetFrameDB(unit, 'font')
			local value = BieChuFrame:GetFrameDB(unit, 'value')
			local percent = BieChuFrame:GetFrameDB(unit, 'percent')

			-- 定位
			if point then
				item.frame:ClearAllPoints()
				if point.parent then
					item.frame:SetPoint(point.anchor, getglobal(point.parent), point.offsetX, point.offsetY)
				else
					item.frame:SetPoint(point.anchor, point.offsetX, point.offsetY)
				end
			end

			-- 缩放
			local scale = BieChuFrame:GetFrameDB(unit, 'scale')
			if scale and type(scale) == 'number' then item.frame:SetScale(scale) end

			-- 头像图标
			if item.frame.portrait then
				SetPortraitTexture(item.frame.portrait, unit)
				if not item.classPortrait then
					item.classPortrait = item.frame:CreateTexture(nil, 'ARTWORK')
					item.classPortrait:SetSize(item.frame.portrait:GetSize())
					item.classPortrait:SetPoint(item.frame.portrait:GetPoint())
					item.classPortrait:SetTexture('Interface\\TargetingFrame\\UI-Classes-Circles')
					item.classPortrait:SetAlpha(0)
				end
			end

			-- 体力值
			if item.health then

				-- 离线/死亡/幽灵
				if not item.state then
					_ = CreateFrame('Frame', nil, item.health)
					_:SetFrameLevel(item.health:GetFrameLevel() + 1)
					item.state = _:CreateFontString(nil, 'OVERLAY')
					item.state:SetPoint('CENTER', item.health)
					if font then item.state:SetFont(font.name, font.size + 2, font.flags) end
					item.state:SetVertexColor(1, 0.8 , 0)
				end

				if value and not item.health.value then
					item.value = value
					item.health.value = _:CreateFontString(nil, 'OVERLAY')
					item.health.value:SetPoint(value.anchor, item.health, value.offsetX or 0, value.offsetY or 0)
					if font then item.health.value:SetFont(font.name, font.size, font.flags) end
				end

				if percent and not item.health.percent then
					item.health.percent = _:CreateFontString(nil, 'OVERLAY')
					item.health.percent:SetPoint(percent.anchor, item.health, percent.offsetX or 0, percent.offsetY or 0)
					if font then item.health.percent:SetFont(font.name, font.size, font.flags) end
				end
			end

			-- 法力值
			if item.mana then
				_ = CreateFrame('Frame', nil, item.mana)
				_:SetFrameLevel(item.mana:GetFrameLevel() + 1)
				if value and not item.mana.value then
					item.mana.value = _:CreateFontString(nil, 'OVERLAY')
					item.mana.value:SetPoint(value.anchor, item.mana, (value.offsetX or 0), (value.offsetY or 0))
					if font then item.mana.value:SetFont(font.name, font.size, font.flags) end
				end

				if percent and not item.mana.percent then
					item.mana.percent = _:CreateFontString(nil, 'OVERLAY')
					item.mana.percent:SetPoint(percent.anchor, item.mana, percent.offsetX or 0, percent.offsetY or 0)
					if font then item.mana.percent:SetFont(font.name, font.size, font.flags) end
				end
			end

			-- 隐藏选项
			if item.hide and type(item.hide) == 'table' then
				for _, hide in pairs(item.hide) do
					hide:SetAlpha(0)
					hide:Hide()
				end
			end
		end
	end
end

-- 框体更新
function BieChuFrame:frameUpdate(unit)
	local item
	if type(unit) == 'string' then item = BieChuFrame.frameList[unit] end
	if not item or not item.frame then return end
	if not UnitExists(unit) then
		item.frame:Hide()
		return
	end

	item.frame:Show()

	-- 创建的对像
	if item.create then
		if item.mana then
			if UnitIsDeadOrGhost(unit) or UnitPower(unit) == 0 or UnitPowerMax(unit) == 0 then
				item.mana:SetValue(0)
			else
				item.mana:SetValue(UnitPower(unit) / UnitPowerMax(unit))
			end
			local barColor = GetPowerBarColor(UnitPowerType(unit))
			if barColor then item.mana:SetStatusBarColor(barColor.r, barColor.g, barColor.b) end
		end

		if item.health then
			if UnitIsDeadOrGhost(unit) then
				item.health:SetValue(0)
			else
				item.health:SetValue(UnitHealth(unit) / UnitHealthMax(unit))
			end
		end
	end

	-- 头像
	local classPortrait = BieChuFrame:GetFrameDB(unit, 'classPortrait')
	if item.frame.portrait then
		local coord = CLASS_ICON_TCOORDS[select(2,UnitClass(unit))]
		if classPortrait and coord and UnitIsPlayer(unit) then
			item.frame.portrait:SetAlpha(0)
			if item.classPortrait then
				item.classPortrait:SetTexCoord(unpack(coord))
				item.classPortrait:SetAlpha(1)
			end
		else
			SetPortraitTexture(item.frame.portrait, unit)
			item.frame.portrait:SetAlpha(1)
			if item.classPortrait then item.classPortrait:SetAlpha(0) end
		end
	end

	-- 体力条
	if item.health then

		-- 体力条背景色
		if BieChuFrame:GetFrameDB(unit, 'healthColor') then item.health:SetStatusBarColor(BieChuFrame:HealthColor(unit, BieChuFrame:GetFrameDB(unit, 'healthColor'))) end

		-- 状态
		if item.state then
			if not UnitIsConnected(unit) and UnitIsPlayer(unit) then
				item.state:Show()
				item.state:SetText('离线')
			elseif UnitIsGhost(unit) then
				item.state:Show()
				item.state:SetText('幽灵')
			elseif UnitIsDeadOrGhost(unit) then
				item.state:Show()
				item.state:SetText('死亡')
			elseif not UnitIsVisible(unit) and health == 1 then
				item.state:Show()
				item.state:SetText('未知')
			else
				item.state:SetText()
			end
		end

		-- 体力值
		if item.state and item.state:GetText() then
			if item.health.value then item.health.value:SetText() end
			if item.health.percent then item.health.percent:SetText() end
		else
			if item.health.value then item.health.value:SetText(BieChuFrame:formatValue(UnitHealth(unit))) end
			if item.health.percent then item.health.percent:SetText(math.floor((UnitHealth(unit) /  UnitHealthMax(unit)) * 100)..'%') end
		end
	end

	-- 法力条
	if item.mana then
		local mana = UnitPower(unit)
		local manaMax = UnitPowerMax(unit)
		if mana == 0 or manaMax == 0 or item.state and item.state:GetText() then
			if item.mana.value then item.mana.value:SetText() end
			if item.mana.percent then item.mana.percent:SetText() end
		else
			if item.mana.value then
				item.mana.value:SetText(BieChuFrame:formatValue(mana))
				item.mana.value:ClearAllPoints()
			end
			if UnitPowerType(unit) == 0 then
				if item.mana.value then item.mana.value:SetPoint(item.value.anchor, item.mana, (item.value.offsetX or 0), (item.value.offsetY or 0)) end
				if item.mana.percent then item.mana.percent:SetText(math.floor((mana / manaMax) * 100)..'%') end
			else
				if item.mana.value then item.mana.value:SetPoint('CENTER', item.mana, 0, (item.value.offsetY or 0)) end
				if item.mana.percent then item.mana.percent:SetText() end
			end
		end
	end
end

-- 等级文字位置调整
PlayerLevelText:SetPoint('CENTER', PlayerFrame, -61, -17)
TargetFrame.levelText:SetPoint("TOP", TargetFrame, 62, -61)
FocusFrame.levelText:SetPoint("TOP", FocusFrame, 62, -61)

-- 设置默认名字
PlayerFrame.name:SetFont(STANDARD_TEXT_FONT, 13, 'OUTLINE')
TargetFrame.name:SetFont(STANDARD_TEXT_FONT, 13, 'OUTLINE')
FocusFrame.name:SetFont(STANDARD_TEXT_FONT, 13, 'OUTLINE')
PlayerFrame.name:SetWidth(130)
TargetFrame.name:SetWidth(130)
FocusFrame.name:SetWidth(130)

-- 绑定拖动对像
BieChuFrame:DragFarmes(PlayerFrame) -- 玩家
BieChuFrame:DragFarmes(FocusFrame) -- 焦点
BieChuFrame:DragFarmes(TargetFrame) -- 目标

-- 界面设置可以拖动
BieChuFrame:DragFarmes(InterfaceOptionsFrame, 1, 1)

-- 团队设置可以拖动
BieChuFrame:DragFarmes(FriendsFrame, 1, 1)


hooksecurefunc('TextStatusBar_UpdateTextString', function(self)
	if self.unit then
		local unit = self.unit
		if unit == 'focus-target' then unit ='focustarget' end
		BieChuFrame:frameUpdate(unit)
		if BieChuFrame:PartyGID(unit) then BieChuFrame:frameUpdate('party' .. BieChuFrame:PartyGID(unit) ..'target') end
	end
end)

for _, event in pairs({
	'PLAYER_ENTERING_WORLD', --进入世界
	'GROUP_ROSTER_UPDATE', -- 队伍变更
	'RAID_ROSTER_UPDATE', -- 团队变更
	'UNIT_POWER_FREQUENT', -- 能量/法力/集中值变化
	'UNIT_HEALTH_FREQUENT', -- 体力值变化
	"UNIT_PET", -- 宠物变化
	'UNIT_PHASE', -- 距离变化
	'UNIT_TARGET', -- 目标变化
	'UNIT_FACTION', -- 发现宠物
	'UNIT_PORTRAIT_UPDATE', -- 头像变化
	'PLAYER_FOCUS_CHANGED', -- 焦点目标变化
}) do
	BieChuFrame:RegisterEvent(event)
end
BieChuFrame:SetScript('OnEvent', function(self, event, unit)
	if event == 'PLAYER_ENTERING_WORLD' or event == 'GROUP_ROSTER_UPDATE' or event == 'RAID_ROSTER_UPDATE' then
		self:AutoHideRaidContainer()
		if event == 'PLAYER_ENTERING_WORLD' then
			BieChuFrame:frameCreate()
		end
		for unit in pairs(self.frameList) do
			if unit then self:frameUpdate(unit) end
		end
	elseif event == 'PLAYER_FOCUS_CHANGED' then
		self:frameUpdate('focus')
		self:frameUpdate('focustarget')
	elseif event == 'UNIT_PET' then
		if self:PartyGID(unit) then self:frameUpdate('partypet'.. self:PartyGID(unit)) end
	elseif event == 'UNIT_TARGET' then
		self:frameUpdate(unit)
		if unit == 'player' then
			self:frameUpdate('target')
			self:frameUpdate('targettarget')
		elseif unit == 'target' or unit == 'focus' then
			self:frameUpdate(unit ..'target')
		elseif self:PartyGID(unit) then
			self:frameUpdate('party'.. self:PartyGID(unit) ..'target')
		end
	elseif event == 'UNIT_POWER_FREQUENT' or event == 'UNIT_HEALTH_FREQUENT' or event == 'UNIT_PHASE' or event == 'UNIT_PORTRAIT_UPDATE' or event == 'UNIT_FACTION' then
		self:frameUpdate(unit)
		if self:PartyGID(unit) then
			self:frameUpdate(unit ..'target')
		end
	else
		-- print(unit, event)
	end
end)
