BieChuDB.partypet = BieChuDB.partypet or {
	scale = 0.65,
	font = {
		name = STANDARD_TEXT_FONT,
		size = 14,
		flags = 'OUTLINE',
	},
	value = {
		anchor = 'RIGHT',
		offsetX = 35,
	},
	percent = false,
	point = {
		anchor = 'RIGHT',
		offsetX = 111,
		offsetY = 4,
	},
}

for id = 1, MAX_PARTY_MEMBERS do
	local partypet = 'partypet'.. id

	BieChuFrame.frameList[partypet] = {
		frame = CreateFrame('Button', 'BC_Party'.. id ..'PetFrame', getglobal('PartyMemberFrame'.. id), 'SecureUnitButtonTemplate'),
		unit = partypet,
		create = 1,
	}
	BieChuFrame.frameList[partypet].frame:SetSize(128, 64)

	-- 点击选择和菜单
	SecureUnitButton_OnLoad(BieChuFrame.frameList[partypet].frame, partypet)

	-- 背景
	BieChuFrame.frameList[partypet].bg = CreateFrame('StatusBar', nil, BieChuFrame.frameList[partypet].frame)
	BieChuFrame.frameList[partypet].bg:SetAllPoints(BieChuFrame.frameList[partypet].frame)
	BieChuFrame.frameList[partypet].bg:SetStatusBarTexture('Interface\\TargetingFrame\\UI-TargetofTargetFrame')
	BieChuFrame.frameList[partypet].bg:SetFrameLevel(2)

	-- 头像
	BieChuFrame.frameList[partypet].frame.portrait = BieChuFrame.frameList[partypet].frame:CreateTexture(nil, 'ARTWORK')
	BieChuFrame.frameList[partypet].frame.portrait:SetSize(34, 34)
	BieChuFrame.frameList[partypet].frame.portrait:SetPoint('TOPLEFT', 7, -7)
	SetPortraitTexture(BieChuFrame.frameList[partypet].frame.portrait, partypet)

	-- 体力条
	BieChuFrame.frameList[partypet].health = CreateFrame('StatusBar', nil, BieChuFrame.frameList[partypet].frame)
	BieChuFrame.frameList[partypet].health:SetSize(46, 7)
	BieChuFrame.frameList[partypet].health:SetPoint('TOPLEFT', 45, -15)
	BieChuFrame.frameList[partypet].health:SetStatusBarTexture('Interface\\TargetingFrame\\UI-StatusBar')
	BieChuFrame.frameList[partypet].health:SetFrameLevel(1)
	BieChuFrame.frameList[partypet].health:SetMinMaxValues(0, 1)

	-- 法力条
	BieChuFrame.frameList[partypet].mana = CreateFrame('StatusBar', nil, BieChuFrame.frameList[partypet].frame)
	BieChuFrame.frameList[partypet].mana:SetSize(46, 7)
	BieChuFrame.frameList[partypet].mana:SetPoint('TOPLEFT', 45, -25)
	BieChuFrame.frameList[partypet].mana:SetStatusBarTexture('Interface\\TargetingFrame\\UI-StatusBar')
	BieChuFrame.frameList[partypet].mana:SetFrameLevel(1)
	BieChuFrame.frameList[partypet].mana:SetMinMaxValues(0, 1)

	BieChuFrame.frameList[partypet].frame.hide = {
		getglobal('PartyMemberFrame'.. id ..'PetFrame') -- 隐藏默认队友宠物头像
	}
end
-- BieChuFrame:frameCreate(BieChuFrame.frameList[partypet])
