BieChuDB.partytarget = BieChuDB.partytarget or {
	font = {
		name = STANDARD_TEXT_FONT,
		size = 10,
		flags = 'OUTLINE',
	},
	value = {
		anchor = 'RIGHT',
	},
	percent = {
		anchor = 'LEFT',
	},
	point = {
		anchor = 'RIGHT',
		offsetX = 196,
		offsetY = -7,
	},
	classPortrait = true,
}

for id = 1, MAX_PARTY_MEMBERS do
	local partytarget = 'party'.. id ..'target'
	BieChuFrame.frameList[partytarget] = {
		frame = CreateFrame('Button', 'BC_Party'.. id ..'TargetFrame', getglobal('PartyMemberFrame'.. id), 'SecureUnitButtonTemplate'),
		unit = partytarget,
		create = 1,
	}
	BieChuFrame.frameList[partytarget].frame:SetSize(128, 64)

	-- 点击选择和菜单
	SecureUnitButton_OnLoad(BieChuFrame.frameList[partytarget].frame, partytarget)

	-- 背景
	BieChuFrame.frameList[partytarget].bg = CreateFrame('StatusBar', nil, BieChuFrame.frameList[partytarget].frame)
	BieChuFrame.frameList[partytarget].bg:SetAllPoints(BieChuFrame.frameList[partytarget].frame)
	BieChuFrame.frameList[partytarget].bg:SetStatusBarTexture('Interface\\TargetingFrame\\UI-PartyFrame')
	BieChuFrame.frameList[partytarget].bg:SetFrameLevel(2)

	-- 头像
	BieChuFrame.frameList[partytarget].frame.portrait = BieChuFrame.frameList[partytarget].frame:CreateTexture(nil, 'ARTWORK')
	BieChuFrame.frameList[partytarget].frame.portrait:SetSize(34, 34)
	BieChuFrame.frameList[partytarget].frame.portrait:SetPoint('TOPLEFT', 8, -8)
	SetPortraitTexture(BieChuFrame.frameList[partytarget].frame.portrait, partytarget)

	-- 体力条
	BieChuFrame.frameList[partytarget].health = CreateFrame('StatusBar', nil, BieChuFrame.frameList[partytarget].frame)
	BieChuFrame.frameList[partytarget].health:SetSize(70, 8)
	BieChuFrame.frameList[partytarget].health:SetPoint('TOPLEFT', 46, -11)
	BieChuFrame.frameList[partytarget].health:SetStatusBarTexture('Interface\\TargetingFrame\\UI-StatusBar')
	BieChuFrame.frameList[partytarget].health:SetFrameLevel(1)
	BieChuFrame.frameList[partytarget].health:SetMinMaxValues(0, 1)

	-- 法力条
	BieChuFrame.frameList[partytarget].mana = CreateFrame('StatusBar', nil, BieChuFrame.frameList[partytarget].frame)
	BieChuFrame.frameList[partytarget].mana:SetSize(70, 8)
	BieChuFrame.frameList[partytarget].mana:SetPoint('TOPLEFT', 46, -19)
	BieChuFrame.frameList[partytarget].mana:SetStatusBarTexture('Interface\\TargetingFrame\\UI-StatusBar')
	BieChuFrame.frameList[partytarget].mana:SetFrameLevel(1)
	BieChuFrame.frameList[partytarget].mana:SetMinMaxValues(0, 1)

	BieChuFrame.frameList[partytarget].frame.hide = {
		getglobal('PartyTargetFrame'..id..'Name'),
	}
end
-- BieChuFrame:frameCreate(BieChuFrame.frameList[partytarget])
