﻿if select(2, UnitClass('player')) ~= 'DRUID' then return end
local frame = CreateFrame('Frame', 'BC_DruidBar', PlayerFrameManaBar)
frame:SetSize(125, 16)
frame:SetPoint('CENTER', 2, -12)

frame.border = CreateFrame('StatusBar', nil, frame)
frame.border:SetAllPoints(frame)
frame.border:SetStatusBarTexture('Interface\\Tooltips\\UI-StatusBar-Border')
frame.border:SetFrameLevel(2)

frame.mana = CreateFrame('StatusBar', nil, frame)
frame.mana:SetSize(118, 10)
frame.mana:SetPoint('LEFT', 3, 0)
frame.mana:SetStatusBarTexture('Interface\\TargetingFrame\\UI-StatusBar')
frame.mana:SetStatusBarColor(0, 0, 1, 1)
frame.mana:SetMinMaxValues(0, 1)
frame.mana:SetFrameLevel(1)

frame.mana.value = frame:CreateFontString(nil, 'OVERLAY')
frame.mana.value:SetPoint('LEFT', 5, -0.5)
frame.mana.value:SetFont(STANDARD_TEXT_FONT, 13, 'OUTLINE')
frame.mana.value:SetVertexColor(1, 1, 1)

frame.mana.percent = frame:CreateFontString(nil, 'OVERLAY')
frame.mana.percent:SetPoint('RIGHT', -5, -0.5)
frame.mana.percent:SetFont(STANDARD_TEXT_FONT, 13, 'OUTLINE')
frame.mana.percent:SetVertexColor(1, 1, 1)

frame:RegisterEvent('PLAYER_ENTERING_WORLD')
frame:RegisterEvent('UPDATE_SHAPESHIFT_FORM', 'player')
frame:RegisterEvent('UNIT_POWER_FREQUENT', 'player')
frame:SetScript('OnEvent', function(self, event, ...)
	if event == 'PLAYER_ENTERING_WORLD' or event == 'UPDATE_SHAPESHIFT_FORM' or select(2, ...) == 'MANA' then
		if UnitPowerType('player') == 0 then
			self:Hide()
		else
			self:Show()
			local value = UnitPower('player', 0)
			local percent = value / UnitPowerMax('player', 0)
			self.mana.value:SetText(value)
			self.mana.percent:SetText(math.floor(percent * 100) .. '%')
			self.mana:SetValue(percent)
		end
	end
end)
